package it.geosolutions.geofence.gui.client.service;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface InstancesManagerRemoteServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.InstancesManagerRemoteService
     */
    void getInstances( int offset, int limit, boolean full, AsyncCallback<com.extjs.gxt.ui.client.data.PagingLoadResult<it.geosolutions.geofence.gui.client.model.GSInstance>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.InstancesManagerRemoteService
     */
    void getInstance( int offset, int limit, long id, AsyncCallback<it.geosolutions.geofence.gui.client.model.GSInstance> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.InstancesManagerRemoteService
     */
    void saveInstance( it.geosolutions.geofence.gui.client.model.GSInstance instance, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.InstancesManagerRemoteService
     */
    void deleteInstance( it.geosolutions.geofence.gui.client.model.GSInstance instance, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see it.geosolutions.geofence.gui.client.service.InstancesManagerRemoteService
     */
    void testConnection( it.geosolutions.geofence.gui.client.model.GSInstance instance, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static InstancesManagerRemoteServiceAsync instance;

        public static final InstancesManagerRemoteServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (InstancesManagerRemoteServiceAsync) GWT.create( InstancesManagerRemoteService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "InstancesManagerRemoteService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
